module CPU( Rb1, Rb2, Rb3, c, s, a, b);

	output[7:0]	Rb1, Rb2, Rb3;
	reg[7:0]				R1, R2, R3;
	wire[7:0]			t;
	input[7:0]		a, b;
	input[2:0]		s;
	input							c;
	wire							w1;

	assign						Rb1 = R1;
	assign						Rb2 = R2;
	assign						Rb3 = R3;

	//Connecting ALU
	wire[1:0]			mys = {(s[2] & s[1]), ((s[2] & ~s[1]) | (s[2] & s[0]) | (~s[2] & s[1]))};
	wire							ci = (s[1] & ~s[0]) | (s[2] & ~s[1]);
	wire							selecta = (~s[1] & s[0]) | (s[2] & s[0]) | (s[1] & ~s[0]);

	ALU alu( t, w1, mys, a, b, selecta, ci);

	initial
	begin
		R1 = a;
		R2 = b;
	end

	always @ ( posedge c)
	begin
		case( s)
			3'b001:	R3 = t;
			3'b010:	R3 = t;
			3'b011:	R2 = t;
			3'b100:	R2 = t;
			3'b101:	R3 = t;
			3'b110:	R1 = t;
			3'b111:	R1 = t;
		endcase
	end

endmodule