module Room( open, close, in, out, ent, t, clk);

input					in, out, t, clk, ent;
output				open, close;
reg					state, next;
wire[3:0]	c;
wire 					up, en;
reg 					clr;

assign close = (~|c);
assign open = state;
assign en = in ^ out;
assign up = in;

counter count ( c, up, clk, clr, en);

always @(state or c or posedge in or posedge ent or t)
begin
	case(state)
		1'b0: begin
						next = 1'b0;

						if( ~&c && ent && t)
							next = 1'b1;
					end
		1'b1: begin
						next = 1'b1;

						if( in)
							next = 1'b0;
					end
	endcase
end

always @(posedge clk)
		state = next;

initial
begin
	state = 0;
	clr = 0;
	#1	clr=1;
end

endmodule
